=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingMouseHandler.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingMouseHandler.java	2022-02-18 17:35:06 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/swing/SwingMouseHandler.java	2022-03-09 23:13:09 +0000
@@ -36,6 +36,30 @@
 ** 016 HC  20190806 Implemented SetParent Windows native function and the system-level widget
 **                  hierarchy.
 ** 017 VVT 20220218 Missing @Override annotations added, Javadocs and other cosmetic fixes.
+**     VVT 20220306 1) mouseEntered made no-op: all necessary actions are taken in the first mouse move
+**                     event. The reason is that when a mouse pointer enters a widget, *two* events
+**                     are generated simultaneously: the ENTER and the MOVE events.
+**                  2) mouseExited: call to findMouseSource eliminated, the correct mouse source is in
+**                     lastHoveredWidget field already.
+**                  3) mouseDragged, mouseWheelMoved: the mouse source widget is explicitly passed to
+**                     postMouseEvent.
+**                  4) mouseMoved:
+**                     * where is no need to execute code as a Runnable exit lambda, so the lambda body
+**                       was inlined.
+**                     * the complex method logic made simple:
+**                        * if the widget under mouse was not changed, then do nothing in this method (just
+**                          call super method) and exit.
+**                        * otherwise if previous widget (lastHoveredWidget) is not null, then send
+**                          EXIT event to it.
+**                        * send ENTER event to the new widget.
+**                  5) findMouseSource(MouseEvent): the local variable parent renamed to mouseSourceWithId,
+**                     since the old name was misleading.
+**                  6) processAction(MouseEvent): the value returned by findMouseSource(e) used instead of
+**                     null.
+**                  7) processAction: the argument is asserted never be null; method made static and renamed to
+**                     processActions.
+**                  8) Method findMouseSource(MouseEvent) pulled up to MouseHandler to make it accessible from
+**                     WebMouseHandler.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -92,20 +116,14 @@
 
 package com.goldencode.p2j.ui.client.gui.driver.swing;
 
-import java.awt.Component;
-import java.awt.event.MouseEvent;
-import java.awt.event.MouseWheelEvent;
-import java.util.ArrayList;
-import java.util.HashMap;
+import java.awt.*;
+import java.awt.event.*;
+import java.util.*;
 import java.util.List;
-import java.util.Map;
+
 import com.goldencode.p2j.security.*;
-import com.goldencode.p2j.ui.WidgetId;
+import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.client.*;
-import com.goldencode.p2j.ui.client.event.*;
-import com.goldencode.p2j.ui.client.gui.EditorGuiImpl;
-import com.goldencode.p2j.ui.client.gui.LabelGuiImpl;
-import com.goldencode.p2j.ui.client.gui.ScrollPaneGuiImpl;
 import com.goldencode.p2j.ui.client.gui.driver.*;
 import com.goldencode.p2j.ui.client.widget.*;
 
@@ -152,10 +170,7 @@
       // serialize this call on the OS event queue to prevent race condition
       tc.invokeLaterOS(() ->
       {
-         if (!processAction(e))
-         {
-            SwingMouseHandler.super.mouseClicked(e);
-         }
+         defaultProcessEvent(e, findMouseSource(e));
       });
    }
 
@@ -182,10 +197,7 @@
          pressed = true;
          delayedMouseExited = null;
          
-         if (!processAction(e))
-         {
-            SwingMouseHandler.super.mousePressed(e);
-         }
+         defaultProcessEvent(e, findMouseSource(e));
       });
    }
 
@@ -215,10 +227,7 @@
             delayedMouseExited = null;
          }
          
-         if (!processAction(e))
-         {
-            SwingMouseHandler.super.mouseReleased(e);
-         }
+         defaultProcessEvent(e, findMouseSource(e));
       });
    }
 
@@ -229,31 +238,11 @@
     * @param    e
     *           The mouse event.
     */
+   @Override
    public void mouseEntered(MouseEvent e)
    {
-      if (!canProcessMouse())
-      {
-         return;
-      }
-      
-      // serialize this call on the OS event queue to prevent race condition
-      tc.invokeLaterOS(() ->
-      {
-         Widget<?> mouseSource = findMouseSource(e);
-         lastHoveredWidget = mouseSource;
-         
-         if (mouseSource != null)
-         {
-            processAction(mouseSource, e); // calls mouseSource.mouseEntered(e);
-            // call this unconditionally, as the widget needs to be notified that it was exited...
-            tc.postMouseEvent(e, ews.getWindowId(), UiUtils.getWidgetIdAsInt(mouseSource));
-         }
-         
-         if (!processAction(e))
-         {
-            SwingMouseHandler.super.mouseEntered(e);
-         }
-      });
+      // Ignore this event, since it duplicates the MOUSE_MOVED, and all necessary actions
+      // are taken in mouseMoved
    }
    
    /**
@@ -264,7 +253,7 @@
     *           The mouse event.
     */
    @Override
-   public void mouseExited(final MouseEvent e)
+   public void mouseExited(MouseEvent e)
    {
       if (!canProcessMouse())
       {
@@ -280,23 +269,16 @@
             delayedMouseExited = e;
             return;
          }
-         
-         Widget<?> mouseSource = findMouseSource(e);
-         if (mouseSource != null)
+
+         // This can be null on window close.
+         if (lastHoveredWidget != null)
          {
-            processAction(mouseSource, e); // calls mouseSource.mouseExited(e);
-               
+            processActions(lastHoveredWidget, e);
+
             // call this unconditionally, as the widget needs to be notified that it was exited...
-            tc.postMouseEvent(e, ews.getWindowId(),
-                              UiUtils.getWidgetIdAsInt(lastHoveredWidget != null
-                                                        ? lastHoveredWidget : mouseSource));
-         }
-         
-         lastHoveredWidget = null;
-         
-         if (!processAction(e))
-         {
-            SwingMouseHandler.super.mouseExited(e);
+            tc.postMouseEvent(e, ews.getWindowId(), UiUtils.getWidgetIdAsInt(lastHoveredWidget));
+
+            lastHoveredWidget = null;
          }
       });
    }
@@ -319,14 +301,11 @@
       // serialize this call on the OS event queue to prevent race condition
       tc.invokeLaterOS(() ->
       {
-         if (!processAction(e))
-         {
-            SwingMouseHandler.super.mouseWheelMoved(e);
-         }
+         defaultProcessEvent(e, findMouseSource(e));
       });
    }
    
-   /**
+  /**
     * Notification of a mouse dragged event.  If the mouse event can't be processed by the driver
     * directly, it will post it to the event manager.
     * 
@@ -344,10 +323,7 @@
       // serialize this call on the OS event queue to prevent race condition
       tc.invokeLaterOS(() ->
       {
-         if (!processAction(e))
-         {
-            SwingMouseHandler.super.mouseDragged(e);
-         }
+         defaultProcessEvent(e, lastHoveredWidget);
       });
    }
 
@@ -362,7 +338,7 @@
     *           The mouse event.
     */
    @Override
-   public void mouseMoved(final MouseEvent e)
+   public void mouseMoved(MouseEvent e)
    {
       if (!canProcessMouse())
       {
@@ -373,70 +349,47 @@
       tc.invokeLaterOS(() ->
       {
          Widget<?> mouseSource = findMouseSource(e);
-         
-         Runnable exit = () ->
-         {
-            Component src = (Component) e.getSource();
-            
-            if (src.isDisplayable())
-            {
-               MouseEvent exite = new MouseEvent(src,
-                                                 MouseEvent.MOUSE_EXITED,
-                                                 e.getWhen(),
-                                                 e.getModifiers(),
-                                                 e.getX(),
-                                                 e.getY(),
-                                                 e.getClickCount(),
-                                                 false,
-                                                 e.getButton());
-               // lastHoveredWidget.mouseExited(exite);
-               processAction(lastHoveredWidget, exite);
-               // call this unconditionally, as the widget needs to be notified that it was exit...
-               tc.postMouseEvent(exite, ews.getWindowId(), UiUtils.getWidgetIdAsInt(lastHoveredWidget));
-            }
-            lastHoveredWidget = null;
-         };
-         
-         // if the widget has changed, send EXITED/ENTERED events
-         if (lastHoveredWidget != null            &&
-             lastHoveredWidget.ancestor() != null && 
-             (!lastHoveredWidget.isDisplayed() ||
-              lastHoveredWidget.getActualBounds() == null ||
-              !lastHoveredWidget.getActualBounds().contains(e.getX(), e.getY())))
-         {
-            exit.run();
-         }
-         
-         if (lastHoveredWidget != mouseSource &&
-             mouseSource!= null               &&
-             mouseSource.getActualBounds().contains(e.getX(), e.getY()))
-         {
-            if (lastHoveredWidget != null)
-            {
-               exit.run();
-            }
-            
-            MouseEvent entere = new MouseEvent((Component) e.getSource(),
-                                               MouseEvent.MOUSE_ENTERED,
-                                               e.getWhen(),
-                                               e.getModifiers(),
-                                               e.getX(),
-                                               e.getY(),
-                                               e.getClickCount(),
-                                               false,
-                                               e.getButton());
-            // mouseSource.mouseEntered(entere);
-            processAction(mouseSource, entere);
-            // call this unconditionally, as the widget needs to be notified that it was entered...
-            tc.postMouseEvent(entere, ews.getWindowId(), UiUtils.getWidgetIdAsInt(mouseSource));
-            
+
+         int windowId = ews.getWindowId();
+         Component src = (Component) e.getSource();
+         int newWidgetId = UiUtils.getWidgetIdAsInt(mouseSource);
+
+         if (lastHoveredWidget != mouseSource)
+         {
+            // Test if we have to send EXIT
+            if (lastHoveredWidget != null && lastHoveredWidget.ancestor() != null)
+            {
+               MouseEvent exitEvent = new MouseEvent(src, MouseEvent.MOUSE_EXITED,
+                        e.getWhen(), e.getModifiers(), e.getX(), e.getY(), e.getClickCount(),
+                        false, e.getButton());
+               processActions(lastHoveredWidget, exitEvent);
+
+               // call this unconditionally (regardless of the process action result),
+               // as the widget needs to be always notified that it was exited...
+               tc.postMouseEvent(exitEvent, windowId,
+                        UiUtils.getWidgetIdAsInt(lastHoveredWidget));
+
+            }
+
+            if (mouseSource != null)
+            {
+               MouseEvent enterEvent = new MouseEvent(src, MouseEvent.MOUSE_ENTERED,
+                        e.getWhen(), e.getModifiers(), e.getX(), e.getY(), e.getClickCount(),
+                        false, e.getButton());
+               processActions(mouseSource, enterEvent);
+               // call this unconditionally (regardless of the process action result),
+               // as the widget needs to be always notified that it was entered...
+               tc.postMouseEvent(enterEvent, windowId, newWidgetId);
+
+            }
+
             lastHoveredWidget = mouseSource;
          }
          else
          {
-            if (!processAction(e))
+            if (mouseSource != null && !processActions(mouseSource, e))
             {
-               SwingMouseHandler.super.mouseMoved(e);
+               tc.postMouseEvent(e, windowId, newWidgetId);
             }
          }
       });
@@ -491,88 +444,50 @@
    }
 
    /**
-    * Find the mouse source on which the specified event will act, based on coordinates.
-    * 
-    * @param    e
-    *           The event.
-    *           
-    * @return   The mouse source, as returned by {@link Window#findMouseSource}.
-    */
-   private Widget<?> findMouseSource(MouseEvent e)
-   {
-      TopLevelWindow<?> window = (TopLevelWindow<?>) WindowManager.findWindow(ews.getWindowId());
-      if (window == null)
-      {
-         // the window may have been gone when the event was generated
-         // during window destroy
-         return null;
-      }
-      
-      Widget<?> mouseSource = window.findMouseSource(new MouseEvt(e, window));
-      
-      // If mouse source has no ID, find the nearest ancestor with ID 
-      Widget parent = WidgetRegistry.findAncestor(mouseSource, true, t ->
-      {
-         // TODO: to improve/simplify the mouse pointer is over a widget work around to skip labels
-         return UiUtils.getWidgetId(t) != null && !(LabelGuiImpl.class.equals(t.getClass()));
-      });
-      
-      // TODO: move this widget-specific logic into methods that are implemented in the widget
-      // hierarchy so that we do not have direct references to widget classes in this common code
-      if (parent instanceof ScrollPaneGuiImpl && parent.parent() instanceof EditorGuiImpl)
-      {
-         parent = parent.parent();
-      }
-
-      return parent;
-   }
-
-   /**
-    * Determine the widget which will react on the specified event and process any actions
-    * associated with it.
-    * 
-    * @param    e
-    *           The mouse event.
-    *           
-    * @return   See above.
-    */
-   private boolean processAction(MouseEvent e)
-   {
-      return processAction(null, e);
-   }
-
+    * Process action and post mouse event using {@link #lastHoveredWidget} as the mouse source.
+    * 
+    * @param e
+    *        the mouse event.
+    * @param mouseSource
+    *        the widget to post event to, can be {@code null} if no mouse source matches the event
+    */
+   private final void defaultProcessEvent(MouseEvent e, Widget mouseSource)
+   {
+      if (!processActions(mouseSource, e))
+      {
+         // Note: we have to post an event even if null was passed as mouse source,
+         // since for dragging events the effective mouse source may be computed later
+         // as the non-null mouse press event source.
+         tc.postMouseEvent(e, ews.getWindowId(), UiUtils.getWidgetIdAsInt(mouseSource));
+      }
+   }
+   
    /**
     * Process any actions for the given widget and event.
     * 
     * @param    widget
-    *           The widget.  If <code>null</code>, it will be determined by 
-    *           {@link #findMouseSource}.
+    *           The widget. May be {@code null}.
     * @param    e
     *           The mouse event.
     * 
     * @return   {@code true} if at least one action was executed
     */
-   private boolean processAction(Widget<?> widget, final MouseEvent e)
+   private static boolean processActions(Widget<?> widget, MouseEvent e)
    {
-      if (widget == null)
-      {
-         widget = findMouseSource(e);
-      }
-
-      if (widget == null || !(widget.isDisplayed() && widget.isVisible()))
+      if (widget == null || !widget.isDisplayed() || !widget.isVisible())
       {
          return false;
       }
-      
-      WidgetId wid = UiUtils.getWidgetId(widget);
-      
+
+      WidgetId wid = widget.getId();
+
       if (wid == null)
       {
          return false;
       }
-      
+
       List<MouseWidgetAction> actionList = local.get().actions.get(wid.asInt());
-         
+
       if (actionList == null)
       {
          return false;

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/web/GuiWebDriver.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/web/GuiWebDriver.java	2022-02-23 20:38:07 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/web/GuiWebDriver.java	2022-03-06 22:06:22 +0000
@@ -184,6 +184,14 @@
 **     SBI 20220131 Changed resolveResourceId by adding ContentDisposition parameter and changed
 **                  deliverDocumentOutput to use ContentDisposition.INLINE for printed documents.
 **     SBI 20220223 Changed chooseFiles to process accepted files filters for the web client.
+**     VVT 20220224 raiseMouseEvent(): an additional widgetId parameter is passed to window raiseMouseEvent()
+**                  method. Multiple cosmetic fixes: missing @Override annotations added, methods made static
+**                  when possible, closable resource access wrapped with try() statement, unneeded Java casts
+**                  removed.
+**     VVT 20220306 1) raiseMouseEvent: an additional widgetId parameter is passed to window raiseMouseEvent.
+**                  2) Multiple cosmetic fixes: missing @Override annotations added, methods made static when
+**                  possible, closable resource access wrapped with try() statement, unneeded Java casts
+**                  removed.
 */
 
 /*
@@ -314,6 +322,7 @@
    /** A bogus AWT component used to raise mouse events, on notification from the JS code. */
    private static final Component BOGUS_AWT_COMPONENT = new Component()
    {
+      // no-op
    };
    
    /** Actions for hoverable widgets */
@@ -334,7 +343,7 @@
    /** Text sample to calculate scaling factor for variable size fonts. */
    private static final String TEXT_SAMPLE = "QqWwEeRrTtYyUuIiOoPp[{}]|AaSsDdFfGgHhJjKkLl:;'ZzXxCcVvBbNnMn<,>.?/ 1234567890!@#$%^&*()_-+=~`";
    
-   /** Text sample to calculate scaling factor for monospace fonts. */
+   /** Text sample to calculate scaling factor for monospaced fonts. */
    private static final String TEXT_SAMPLE_MONO = "0.0";
    
    /** Delgated implementation for the embedded web server. */
@@ -367,9 +376,6 @@
    /** Owned images is a mapping of a window to its owned images seals. */
    private final Map<Integer, Set<List<Integer>> > ownedImages;
    
-   /** A cache of font metrics objects, by their remote font ID. */
-   private Map<Integer, FontMetricsHelper> fontMetricsCache = new HashMap<>();
-   
    /** A counter for font IDs to be mapped on the js-side. */
    private int nextFontId = 0;
    
@@ -488,6 +494,7 @@
       updateDesktopDimensions(width, height);
 
       // calculate our resource base
+      @SuppressWarnings("resource")
       Resource cpres = EmbeddedWebServerImpl.calcResourceBase(GuiWebDriver.class, "res");
      
       // calculate our welcome page
@@ -600,6 +607,7 @@
    @Override
    public void initRemoteClient()
    {
+      // no-op
    }
 
    /**
@@ -731,6 +739,7 @@
    @Override
    public void injectVT100Key(int keyCode, char charCode)
    {
+      // no-op
    }
    
    /**
@@ -1345,7 +1354,7 @@
     * @param    widgetId
     *           The widget ID.
     * @param    fileNameList
-    *           The oredered file name list to be dropped.
+    *           The ordered file name list to be dropped.
     */
    @Override
    public void startDropTarget(int windowId, int widgetId, List<String> fileNameList)
@@ -1526,7 +1535,7 @@
     * 
     * @return   The key's modifiers bit mask for this mouse event.
     */
-   private int getMouseModifiers(int button, int modifiersMask)
+   private static int getMouseModifiers(int button, int modifiersMask)
    {
       int modifiers = 0;
       // button codes from JS (same as from AWT) 
@@ -1547,21 +1556,21 @@
             break;
          default:
       }
-      if ((modifiersMask & MouseEvent.SHIFT_MASK) != 0)
-      {
-         modifiers |= MouseEvent.SHIFT_DOWN_MASK; 
-      }
-      if ((modifiersMask & MouseEvent.CTRL_MASK) != 0)
-      {
-         modifiers |= MouseEvent.CTRL_DOWN_MASK; 
-      }
-      if ((modifiersMask & MouseEvent.META_MASK) != 0)
-      {
-         modifiers |= MouseEvent.META_DOWN_MASK; 
-      }
-      if ((modifiersMask & MouseEvent.ALT_MASK) != 0)
-      {
-         modifiers |= MouseEvent.ALT_DOWN_MASK; 
+      if ((modifiersMask & InputEvent.SHIFT_MASK) != 0)
+      {
+         modifiers |= InputEvent.SHIFT_DOWN_MASK; 
+      }
+      if ((modifiersMask & InputEvent.CTRL_MASK) != 0)
+      {
+         modifiers |= InputEvent.CTRL_DOWN_MASK; 
+      }
+      if ((modifiersMask & InputEvent.META_MASK) != 0)
+      {
+         modifiers |= InputEvent.META_DOWN_MASK; 
+      }
+      if ((modifiersMask & InputEvent.ALT_MASK) != 0)
+      {
+         modifiers |= InputEvent.ALT_DOWN_MASK; 
       }
       
       return modifiers;
@@ -2041,7 +2050,7 @@
     *           The collected mouse widget.
     * @return   The web actions that are handled by the given widget.
     */
-   private RoaringBitmap getWebActions(Widget widget)
+   private static RoaringBitmap getWebActions(Widget widget)
    {
       return MouseHandler.getCachedActions(widget.getId().asInt(), () ->
       {
@@ -2128,6 +2137,7 @@
     * @param isWaitState
     *        wait state
     */
+   @Override
    public void propagateWaitState(boolean isWaitState)
    {
       websock.propagateWaitState(isWaitState);
@@ -2359,7 +2369,7 @@
     * @return  <code>TRUE</code> if the widget is inside visible frame or standalone,
     *          <code>FALSE</code> otherwise.
     */
-   private boolean isInsideVisibleFrameOrStandalone(Widget wid)
+   private static boolean isInsideVisibleFrameOrStandalone(Widget wid)
    {
       // get the enclosing frame
       Frame fr = UiUtils.locateFrame(wid);
@@ -2493,14 +2503,14 @@
     * @param    icon
     *           The name of custom cursor.
     */
+   @Override
    public void setCursor(String icon)
    {
       String mimeType = mimeType(icon.toLowerCase());
       if (mimeType != null)
       {
-         try
-         {
-            InputStream resource = ThemeManager.getCurrentTheme().getBinaryResource(icon);
+         try(InputStream resource = ThemeManager.getCurrentTheme().getBinaryResource(icon))
+         {            
             if (resource != null)
             {
                byte[] image = ByteStreams.toByteArray(resource);            
@@ -2544,6 +2554,7 @@
     * @param ptr
     *           mouse pointer
     */
+   @Override
    public void propagate(int windowId, int wid, MousePtrWrapper ptr)
    {
       websock.setMousePtr(windowId, wid, ptr); 
@@ -2733,12 +2744,12 @@
          // special processing for monospaced fonts
          if (scaleX <= 1.1)
          {
-            wRes = (int)Math.ceil((double)wRes * scaleX);
+            wRes = (int)Math.ceil(wRes * scaleX);
          }
       }
       else
       {
-         wRes = (int)Math.ceil((double)super.getTextWidth(text, fd) * scaleX);
+         wRes = (int)Math.ceil(super.getTextWidth(text, fd) * scaleX);
       }
       
       return wRes;
@@ -3177,11 +3188,8 @@
     * 
     * @param    uriString
     *           The target resource.
-    * 
-    * @throws   IOException
-    *           For IO errors during file operations.
     */
-   private String writeLauncherWrapper(String uriString)
+   private static String writeLauncherWrapper(String uriString)
    {
       Path wrapperFile;
       
@@ -3215,7 +3223,7 @@
     *          
     * @return  MIME type if image <code>null</code> if not.
     */
-   private String mimeType(String icon)
+   private static String mimeType(String icon)
    {
       if (icon == null)
       {

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/web/WebMouseDirectManipulation.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/web/WebMouseDirectManipulation.java	2022-02-18 17:35:06 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/web/WebMouseDirectManipulation.java	2022-03-06 21:49:25 +0000
@@ -10,6 +10,7 @@
 ** 002 HC  20200403 Improved web gui widget direct manipulation to allow widget move, and to
 **                  limit the bounds of widget move and resize.
 ** 003 VVT 20220218 Javadocs and other cosmetic fixes.
+**     VVT 20220306 Javadocs and other cosmetic fixes.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -65,14 +66,13 @@
 */
 package com.goldencode.p2j.ui.client.gui.driver.web;
 
-import java.awt.event.MouseEvent;
+import java.awt.event.*;
 
 import com.goldencode.p2j.ui.*;
-import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.event.*;
 import com.goldencode.p2j.ui.client.gui.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
-import com.goldencode.p2j.ui.client.event.*;
 import com.goldencode.p2j.ui.client.widget.*;
 
 /**
@@ -207,11 +207,9 @@
     * 
     * @param    evt
     *           The mouse event details.
-    * @param    firstCall
-    *           Flag indicating first call in a current drag session.
     */
    @Override
-   public void processDrag(MouseEvent evt, boolean firstCall)
+   protected void processDrag(MouseEvent evt)
    {
       // box selection mode needs the event to be sent on actual start drag instead of press
       if (boxSelecting)

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/web/WebMouseHandler.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/web/WebMouseHandler.java	2022-01-04 11:25:39 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/web/WebMouseHandler.java	2022-03-06 21:49:25 +0000
@@ -21,6 +21,10 @@
 ** 011 HC  20190806 Implemented SetParent Windows native function and the system-level widget
 **                  hierarchy.
 ** 012 AL2 20220104 Resolve dragging editors with the initial widget when no resolved target.
+**     VVT 20220306 Javadocs and other cosmetic fixes. raiseMouseEvent:
+**                  * Method MouseHandler.findMouseSource(MouseEvent) is used instead of
+**                    findMouseSource(NativePoint).
+**                  * The unused widgetId arguments eliminated.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -77,9 +81,9 @@
 
 package com.goldencode.p2j.ui.client.gui.driver.web;
 
-import java.awt.event.MouseEvent;
-import com.goldencode.p2j.ui.client.*;
-import com.goldencode.p2j.ui.client.gui.*;
+import java.awt.event.*;
+
+import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
 import com.goldencode.p2j.ui.client.widget.*;
 
@@ -97,7 +101,7 @@
     * @param    windowId
     *           Target window id.
     * @param    widgetId
-    *           Target widget id.
+    *           the widget ID or -1 if not known
     */
    public void raiseMouseEvent(MouseEvent event, int windowId, int widgetId)
    {
@@ -105,49 +109,21 @@
       {
          return;
       }
-      tc.invokeLaterOS(() ->
-      {
-         int effectiveWidgetId = widgetId;
-         if (widgetId == -1)
+
+      tc.invokeLaterOS(() -> {
+         Widget effMouseSource = ThinClient.getInstance().getWidget(widgetId);
+         if (effMouseSource == null)
+         {
+            effMouseSource = findMouseSource(event);
+         }
+
+         if (effMouseSource == null)
          {
             tc.postMouseEvent(event, windowId);
          }
          else
          {
-            Widget w = tc.getWidget(widgetId);
-            if (w == null || w.ancestor() == null)
-            {
-               return;
-            }
-
-            if (w instanceof AbstractContainer)
-            {
-               // it needs to get the widget's location with respect to the parent window
-               NativePoint origin = w.screenPhysicalLocation();
-               Widget target = w.findMouseSource(
-                        new NativePoint(event.getX() - origin.x, event.getY() - origin.y));
-               if (target != null && target.getId() != null)
-               {
-                  effectiveWidgetId = target.getId().asInt();
-               }
-               else
-               {
-                  // TODO: move this widget-specific logic into methods that are implemented in
-                  // the widget hierarchy so that we do not have direct references to widget
-                  // classes in this common code
-             
-                  // in a dragging process, the target may be null and still the dragged
-                  // widget to be an editor; therefore ensure that the editor is resolved
-                  // using the actual widgetId (w)
-                  Widget editor = WidgetRegistry.findAncestor((target == null ? w : target), true,
-                                                t -> EditorGuiImpl.class.equals(t.getClass()));
-                  if (editor != null && editor.getId() != null)
-                  {
-                     effectiveWidgetId = editor.getId().asInt();
-                  }
-               }
-            }
-            tc.postMouseEvent(event, windowId, effectiveWidgetId);
+            tc.postMouseEvent(event, windowId, effMouseSource.getId().asInt());
          }
       });
    }

